##
##  hq.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package versions
%define       V_hq_base  0.0.4
%define       V_hq_snap  20200216
%define       V_python   3.7

#   package information
Name:         hq
Summary:      HTML Query Processor
URL:          https://github.com/rbwinslow/hq
Vendor:       Richard B. Winslow
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Text
License:      MIT
Version:      %{V_hq_base}.%{V_hq_snap}
Release:      20200216

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/hq/hq-%{V_hq_snap}.tar.xz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101
BuildPreReq:  python, python-setup
PreReq:       python, python-setup

%description
    HQ is a command-line tool for querying HTML, manipulating data and
    producing results as HTML, JSON or any other format. It's based on
    HQuery, a compact, flexible expression language that started out as
    an XPath implementation but ended up going a few different places.

%track
    prog hq:base = {
        version   = %{V_hq_base}
        url       = https://github.com/rbwinslow/hq/releases
        regex     = v(__VER__)\.tar\.gz
    }
    prog hq:snap = {
        version   = %{V_hq_snap}
        url       = http://download.openpkg.org/components/versioned/hq/
        regex     = hq-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -n hq

%build

%install
    #   install package
    export HOME=`pwd`
    %{l_prefix}/bin/python -m pip \
        install \
        --root=$RPM_BUILD_ROOT \
        --prefix=%{l_prefix}/lib/hq \
        --isolated \
        --ignore-installed \
        --no-warn-script-location \
        *

    #   install executable wrapper script
    (   echo "#!/bin/sh"
        echo "PYTHONPATH=%{l_prefix}/lib/python%{V_python}:%{l_prefix}/lib/hq/lib/python%{V_python}/site-packages"
        echo "export PYTHONPATH"
        echo "exec %{l_prefix}/lib/hq/bin/hq \${1+\"\$@\"}"
    ) >hq.sh
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin
    %{l_shtool} install -c -m 755 \
        hq.sh $RPM_BUILD_ROOT%{l_prefix}/bin/hq

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

